var itemid;
var questionId;

var examDataListAI;
var ai_question_index;
var ai_test_type;
var removeStorageType;
var qType = 1;// 题目类型 1.单选 2.多选

var entityId;
var groupType;
var entityteacher;
var entitygrade;
var templateId;
var type;// type=1(题目) 修改 type=2(题目+解析) 

var htmlAppendFlag = false;
var pageNO;
var hasNext = true;
var nextPage = 1;
var prePage = 1;//上一页
var totalPages = 1;//总页数
var name;//item name
var title;//question title
var displayorder;//question displayorder
var bg_pic;

var zt_title;//专题标题
var zt_type = 'qmfx';//专题类型 day_sj 21天暑假
var pic_type;
var list_id;
var config_title;//21day左上角年级显示
var list_title;//list表 - title

var tree_id;//知识点id
var tree_name;//知识点名称
var test_type;//old-不带知识点的  new-带测试点的
var user_answer = '';//用户答案
var answers = '';//参考答案
var result = 0;//0:错误 1：正确
var next_isClick = true;//防止用户重复下一题
var prev_isClick = true;//防止用户重复上一题
var is_ans_pic = 1;//0 没有解析图 1 有解析图

apiready = function() {
	itemid = api.pageParam.itemid;
	pageNO = api.pageParam.pageNO || 1;
	entityId = api.pageParam.entityId;
	groupType = api.pageParam.groupType;
	templateId = api.pageParam.templateId;
	entityteacher = api.pageParam.entityteacher;
	entitygrade = api.pageParam.entitygrade;
	type = api.pageParam.type;
	zt_title = api.pageParam.zt_title;
	list_id = api.pageParam.list_id;
	zt_type = api.pageParam.zt_type;
	pic_type = api.pageParam.pic_type;
	config_title = api.pageParam.config_title;
	list_title = api.pageParam.list_title;
	test_type = api.pageParam.test_type || 'old';
	ai_test_type = api.pageParam.ai_test_type;
	removeStorageType = api.pageParam.removeStorageType;
	ai_question_index = pageNO - 1;
	setStyle();
	// itemid='4b869014-3fef-4cfb-a0f1-45c3f2b1dd6f';
	// itemid='060edf81-47af-4b88-9e43-1a33ac3ef07e';
	const storage = hasPermission(['storage'],'none')[0].granted;
	// console.log(JSON.stringify(storage))
	if(storage){
		//创建本地期末答题记录表
		opendb_common().then(res=>{
			return createQmcs();//创建本地期末答题记录表
		}).then(res=>{
			if (ai_test_type && ai_test_type != 'null') {
				getItemAI(list_id, ai_test_type)
			} else {
				beginTest(itemid);//进入测试
				getItem(itemid);
			}
		}, err=>{
			api.alert({
				msg: JSON.stringify(err)
			})
		});//打开db
	}else{
		api.confirm({
			title:"提示",
			msg:"您未授权存储权限，为确保练习题功能正常运行，需要获取您读写手机存储权限（部分系统提示为：访问设备上的照片、媒体内容和文件），请允许。",
			buttons: [ '确定', '取消' ]
		},ret=>{
			if (ret.buttonIndex==1) {// 确定
				api.requestPermission({
					list: ['storage'],
					code: 10001
				}, res=> {
					let storageFlag = res.list[0].granted;
					if (storageFlag) {
						opendb_common().then(res=>{
							return createQmcs();//创建本地期末答题记录表
						}).then(res=>{
							if (ai_test_type && ai_test_type != 'null') {
								getItemAI(list_id, ai_test_type)
							} else {
								beginTest(itemid);//进入测试
								getItem(itemid);
							}
						}, err=>{
							api.alert({
								msg: JSON.stringify(err)
							})
						});//打开db
					} else {
						api.alert({
							msg: '您可以在 设置->权限->'+(api.appName||'小学同步课堂')+' 中打开存储权限，否则练习题功能无法正常运行'
						},_=>{
							api.closeWin();
						});
					}
				})
			} else {
				api.alert({
					msg: '您可以在 设置->权限->'+(api.appName||'小学同步课堂')+' 中打开存储权限，否则练习题功能无法正常运行'
				},_=>{
					api.closeWin();
				});
			}
			
		})
	}
//	//签到按钮控制
//	var date = new Date().getDate();
//	if($api.getStorage("date") != date) $api.setStorage("date",date);
};

function getItemAI(listId,aiTestType) {
	if (removeStorageType) {
		$api.rmStorage('examDataListAI');
		$api.rmStorage('insertQuestionAI');
		/**
		 * @param type 1、课后练习 2、单元测试 3、期中测试 4、期末
		 * @param id 课后练习：list_id 单元测试：zt_coursekind_id 期中/期末测试：zt_id
		 */
		api.ajax({
			url : examURL + '/question/ai_test?type=' + aiTestType + '&id=' + listId,
			method : 'post',
			cache : false,
			timeout : 30,
			dataType : 'json',
			data : {},
			returnAll : false,
		}, function(ret, err) {
			// console.log(JSON.stringify(ret, null, 4))
			api.hideProgress();
			examDataListAI = ret.data
			let insertQuestionAI = examDataListAI.map((examData, index) => ({
                id: index,
                pageNO: index + 1,
                answers: examData.answers,
                user_answer: '',
                result: result,
                is_ans_pic: is_ans_pic
            }));
			$api.setStorage('examDataListAI', JSON.stringify(examDataListAI));
			$api.setStorage('insertQuestionAI', JSON.stringify(insertQuestionAI));
			getExamDataAI(ai_question_index);
		})
	} else {
		examDataListAI = JSON.parse($api.getStorage('examDataListAI'));
		getExamDataAI(ai_question_index);
	}
}

function getExamDataAI(idx){
	api.hideProgress();
	let { title: questionTitle, optionA, optionB, optionC, optionD, answer, keyPoints, explanation } = examDataListAI[idx]
	answers = examDataListAI[idx].answer;
	qType = examDataListAI[idx].qType;
	if(zt_type=='test_window'){
		bg_pic = '../../../image/pages/qmfx/testing/test_bg'+pic_type+'.png';
	}else{
		// bg_pic = ret.result[0].bg_pic;
		bg_pic = 'https://3jidi-1251017968.cos.ap-guangzhou.myqcloud.com/upload/pics/ott/question/xxtbkcxlxt_bg.jpg'
	}
	getSkinType().then(function(res){
		if(res){
			if(res.indexOf("xx_preview")>-1 && apkType.indexOf("xxtbkt")>-1) $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/xx_v1_test_bg.jpg');
			else if(res.indexOf("cz_preview")>-1 && apkType=="v3_cz_tbkt") $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/cz_v1_test_bg.jpg');
			else if(res.indexOf("gz_preview")>-1 && apkType=="v3_gz_tbkt") $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/gz_v1_test_bg.jpg');
			else $api.attr($api.byId('bg'), 'src', bg_pic);
		}else{
			$api.attr($api.byId('bg'), 'src', bg_pic);
		}
	});
	$('#test_id').text((idx+1)+'/'+examDataListAI.length);
	if((idx+1) == examDataListAI.length){//上、下 一题显示处理
		$('#nextQuestion').hide();
	}else{
		$('#nextQuestion').show();
	}
	if(idx==0){
		$('#prevQuestion').hide();
	}else{
		$('#prevQuestion').show();
	}
	// if(zt_type=='qmfx'){
	// 	$('#title_name').html(zt_title+' <a style="margin-left:20px;">'+name +'：'+ret.result[0].title+'</a>');//标题
	// }else if(['day_sj', 'school_index', 'course_window', 'masterSelected', 'test_window'].includes(zt_type)){
	$('#title_name').html(list_title+' <a style="margin-left:20px;"></a>');//标题
	// }
	if(examDataListAI.explanation){
		is_ans_pic = 1
	}else{
		is_ans_pic = 0
	}
	var html = '';
	html += '<p>【' + (qType == 1 ? '单选题' : '多选题') + '】 ' + questionTitle + '</p>'
    html += '<p>' + optionA + '</p>'
    html += '<p>' + optionB + '</p>'
    html += '<p>' + optionC + '</p>'
    html += '<p>' + optionD + '</p>'
	if (type==2) {
		html += '<p>【答案】' + answer + '</p>'
		html += '<p>【考点】' + keyPoints + '</p>'
		html += '<p>【解析】' + explanation + '</p>'
	}
	if (htmlAppendFlag) {
		$api.append($api.byId('question'), html);
	} else {
		$api.html($api.byId('question'), html);
	}
	next_isClick=true;
	prev_isClick=true;
	reloadSel();
}

//测试前清空本地答案数据
function beginTest(itemid){
	// console.log('itemid---'+itemid)
	var db = api.require('db');
	var userid = $api.getStorage('userid');
	var sql ='DELETE FROM qmcs_v3 where itemid='+'"'+itemid+'"';
	db.selectSql({
	    name: 'payLogDB',
	    sql:sql 
	}, function(ret, err) {
	    if (ret.status) {
	        // console.log(JSON.stringify(ret)+'-ret-beginTest--');
	        insertQuestion(itemid);
	    }else{
	    	alert(JSON.stringify(err)+'-err-beginTest--');
	    }	
	});	
}

function getItem(itemid){
	api.ajax({
		url : examURL + '/item/' + itemid,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		// console.log(JSON.stringify(ret, null, 4))
		if(ret){
			getExamData(ret.name,itemid,pageNO);
		}
	})
}

//获取测试试卷题目 id=treeid
function getExamData(name,id,nowPage){
	api.ajax({
		url : examURL + '/question/' + id+'/'+nowPage,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		// console.log(JSON.stringify(ret, null, 4))
		api.hideProgress();
		if(ret && ret.result.length>0){
			pageNO = nowPage;
			hasNext = ret.hasNext;
			nextPage = ret.nextPage;
			prePage = ret.prePage;
			totalPages = ret.totalPages;
			questionId = ret.result[0].id;
			title = ret.result[0].title;
			displayorder = ret.result[0].displayorder;
			tree_id = ret.result[0].treeId;
			tree_name = ret.result[0].tree_name;
			if(zt_type=='test_window'){
				bg_pic = '../../../image/pages/qmfx/testing/test_bg'+pic_type+'.png';
			}else{
				bg_pic = ret.result[0].bg_pic;
			}
			answers = ret.result[0].answers;
			getSkinType().then(function(res){
				if(res){
					if(res.indexOf("xx_preview")>-1 && apkType.indexOf("xxtbkt")>-1) $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/xx_v1_test_bg.jpg');
					else if(res.indexOf("cz_preview")>-1 && apkType=="v3_cz_tbkt") $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/cz_v1_test_bg.jpg');
					else if(res.indexOf("gz_preview")>-1 && apkType=="v3_gz_tbkt") $api.attr($api.byId("bg"), "src", skinAdd + 'xxtbkt/gz_v1_test_bg.jpg');
					else $api.attr($api.byId('bg'), 'src', bg_pic);
				}else{
					$api.attr($api.byId('bg'), 'src', bg_pic);
				}
			});
			$('#test_id').text(nowPage+'/'+totalPages);
			if(totalPages == nowPage){//上、下 一题显示处理
				$('#nextQuestion').hide();
			}else{
				$('#nextQuestion').show();
			}
			if(pageNO==1){
				$('#prevQuestion').hide();
			}else{
				$('#prevQuestion').show();
			}
			if(zt_type=='qmfx'){
				$('#title_name').html(zt_title+' <a style="margin-left:20px;">'+name +'：'+ret.result[0].title+'</a>');//标题
			
			}else if(['day_sj', 'school_index', 'course_window', 'masterSelected', 'test_window'].includes(zt_type)){
				$('#title_name').html(list_title+' <a style="margin-left:20px;"></a>');//标题
			}
			var html = '';
			if(ret.result[0].analysis_pic){
				is_ans_pic = 1
			}else{
				is_ans_pic = 0
			}
			if(type==2){
				html += '<img onerror="resetImg(this,this.src,5)" src="'+ret.result[0].analysis_pic+'" />';
			}else{
				html += '<img onerror="resetImg(this,this.src,5)" src="'+ret.result[0].contentPic+'" />';
				// console.log(ret.result[0].contentPic)
				// html += '<img onclick="enlarge(\''+ret.result[0].contentPic+'\')" src="'+ret.result[0].contentPic+'" />';
			}
			if (htmlAppendFlag) {
				$api.append($api.byId('question'), html);
			} else {
				$api.html($api.byId('question'), html);
			}
			next_isClick=true;
			prev_isClick=true;
		}else{
			// console.log(JSON.stringify(err))
		}
	});
	reloadSel();
}

function resetImg(imgObj,imgSrc,count) {
	if(count>0){
		imgObj.onerror=function(){
			resetImg(imgObj,imgSrc,count-1);
		};
		setTimeout(function(){
			imgObj.src=imgSrc;
		},2000);
	}else{
		imgObj.onerror=null;
		// imgObj.src="/noImg.png";
	}
}

function reloadSel(){
	$api.attr($api.byId('prevQuestion'), 'src', '../../../image/pages/qmfx/testing/prev_question.png');
	$api.attr($api.byId('nextQuestion'), 'src', '../../../image/pages/qmfx/testing/next_question.png');
}

//放大问题图片
function enlarge(pic){
	api.openFrame({
	    name: 'enlarge',
	    url: './enlargePic.html',
	    rect: {
		    x:0,
		    y:0,
		    w:api.winWidth,
		    h:api.winHeight
	    },
	    pageParam : {
	    	pic : pic
	    }
    });
}

function setStyle() {
	if (zt_type == 'test_window') $api.css($api.byId('title'), 'top:14%');
	$api.css($api.byId('title'), 'line-height:' + api.winHeight * 0.075 + 'px');
	// $api.css($api.byId('option'), 'line-height:' + api.winHeight * 0.145 + 'px');
}

//先在本地数据库生成对应的试题数据
function insertQuestion(itemid){
	api.ajax({
		url : examURL + '/question/' + itemid+'/'+1,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {
				pageSize : 100
			}
		},
		returnAll : false,
	}, function(ret, err) {
		// console.log("inserQmcs_new---",$api.jsonToStr(ret))
		if(ret){		
			for (var i = 0; i < ret.result.length; i++) {
				inserQmcs_new(itemid,ret.result[i].id,ret.result[i].title,(i+1),ret.result[i].displayorder,ret.result[i].treeId,ret.result[i].tree_name);
			}
		}
	});
}

//选择提交答案
function option(userAnswer, index) {
	$api.attr($api.byId('look'), 'src', '../../../image/pages/qmfx/testing/look_all.png');
	var currentOptionElements = Array.from($api.domAll($api.byId('option'), '.answer')).slice(0, 4);
	var currentOption = currentOptionElements[index];
	var currentSrc = $api.attr(currentOption, 'src');
	if (qType == 1) { //单选逻辑
        if (currentSrc.endsWith('_sel.png')) {
            user_answer = ''; // 取消选中
            $api.attr(currentOption, 'src', '../../../image/pages/qmfx/testing/option_' + index + '.png'); // 换回未选中的图片
        } else {
            user_answer = userAnswer;
            for (var i = 0; i < currentOptionElements.length; i++) {
                if (i == index) {
                    $api.attr(currentOptionElements[i], 'src', '../../../image/pages/qmfx/testing/option_' + i + '_sel.png');
                } else {
                    $api.attr(currentOptionElements[i], 'src', '../../../image/pages/qmfx/testing/option_' + i + '.png');
                }
            }
        }
    } else { // 多选逻辑
        if (currentSrc.endsWith('_sel.png')) {
            // 取消选中
            $api.attr(currentOption, 'src', '../../../image/pages/qmfx/testing/option_' + index + '.png');
            user_answer = user_answer.replace(userAnswer, ''); // 从 user_answer 中移除取消选中的选项
        } else {
            // 选中
            $api.attr(currentOption, 'src', '../../../image/pages/qmfx/testing/option_' + index + '_sel.png');
            if (user_answer.includes(userAnswer)) {
                user_answer = user_answer.replace(userAnswer, '') + userAnswer; // 确保选项顺序
            } else {
                user_answer += userAnswer; // 将选项添加到 user_answer
            }
        }
	}
}

//跳到答题卡
function lookAll(obj) {
	api.showProgress({
	    title: '努力加载中...',
	    text: '先喝杯茶...',
	    animationType:'fade',
	    modal: true
	});
	$api.attr(obj, 'src', '../../../image/pages/qmfx/testing/look_all_sel.png');
	// 检查用户答案
	if (user_answer) {
		// 检查用户答案并更新结果
		user_answer = user_answer.length === 1 ? user_answer : user_answer.split('').sort().join('');
		result = user_answer === answers ? 1 : 0;
	}
	if (ai_test_type && ai_test_type != 'null') {
		updateQuestionAI(ai_question_index);
	} else {
		updateQmcs(itemid, questionId, answers, user_answer, result, is_ans_pic);
	}
	api.openWin({
		name : 'checkanswer',
		url : 'checkanswer.html',
		reload:true,
		pageParam : {
			itemid:itemid,
			total_count:totalPages,
			name:name,
			entityId : entityId,
			groupType : groupType,
			templateId : templateId,
			entityteacher:entityteacher,
			entitygrade : entitygrade,
			bg_pic:bg_pic,
			zt_title:zt_title,
			zt_type:zt_type,
			list_id:list_id,
			config_title:config_title,
			list_title:list_title,
			test_type:test_type,
			pic_type: pic_type,
			ai_test_type:ai_test_type
		}
	});
	api.hideProgress();
}

//上一题
function prev_question(obj) {
	if(prev_isClick){
		prev_isClick=false;
		api.showProgress({
		    title: '努力加载中...',
		    text: '先喝杯茶...',
		    animationType:'fade',
		    modal: true
		});
		$api.attr($api.byId('look'), 'src', '../../../image/pages/qmfx/testing/look_all.png');
		$api.attr(obj, 'src', '../../../image/pages/qmfx/testing/prev_question_sel.png');
		var len = $api.domAll($api.byId('option'), '.answer');
		for (var i = 0; i < len.length; i++) {
			$api.attr(len[i], 'src', '../../../image/pages/qmfx/testing/option_' + i + '.png');
		}
		// 处理用户答案
		if (user_answer) {
			// 检查用户答案并更新结果
			user_answer = user_answer.length === 1 ? user_answer : user_answer.split('').sort().join('');
			result = user_answer === answers ? 1 : 0;
		}
		if (ai_test_type && ai_test_type != 'null') {
			updateQuestionAI(ai_question_index);
		} else {
			updateQmcs(itemid, questionId, answers, user_answer, result, is_ans_pic);
		}
		// 重置用户答案和结果
		user_answer = "";
		result = 0;
		ai_question_index -= 1;
		// 获取上一题数据
		if (ai_test_type && ai_test_type != 'null') {
			getExamDataAI(ai_question_index);
		} else {
			getExamData(name, itemid, nextPage);
		}
	}
}

//下一题
function next_question(obj) {
	if(next_isClick){
		next_isClick=false;
		api.showProgress({
		    title: '努力加载中...',
		    text: '先喝杯茶...',
		    animationType:'fade',
		    modal: true
		});
		$api.attr($api.byId('look'), 'src', '../../../image/pages/qmfx/testing/look_all.png');
		$api.attr(obj, 'src', '../../../image/pages/qmfx/testing/next_question_sel.png');
		var len = $api.domAll($api.byId('option'), '.answer');
		for (var i = 0; i < len.length; i++) {
			$api.attr(len[i], 'src', '../../../image/pages/qmfx/testing/option_' + i + '.png');
		}
		// 处理用户答案
		if (user_answer) {
			// 检查用户答案并更新结果
			user_answer = user_answer.length === 1 ? user_answer : user_answer.split('').sort().join('');
			result = user_answer === answers ? 1 : 0;
		}
		if (ai_test_type && ai_test_type != 'null') {
			updateQuestionAI(ai_question_index);
		} else {
			updateQmcs(itemid, questionId, answers, user_answer, result, is_ans_pic);
		}
		// 重置用户答案和结果
		user_answer = "";
		result = 0;
		ai_question_index += 1;
		// 获取下一题数据
		if (ai_test_type && ai_test_type != 'null') {
			getExamDataAI(ai_question_index);
		} else {
			getExamData(name, itemid, nextPage);
		}
	}
}

function updateQuestionAI() {
	// 1. 获取存储的数据
	let insertQuestionAI = JSON.parse($api.getStorage('insertQuestionAI'));

	// 2. 更新对应题目的 user_answer 和 result
	insertQuestionAI[ai_question_index].user_answer = user_answer;
	insertQuestionAI[ai_question_index].result = result;

	// 3. 再次存储更新后的数据
	$api.setStorage('insertQuestionAI', JSON.stringify(insertQuestionAI));
}